######################################################################
# pyukiwiki.skin.ja.cgi - PyukiWiki Default Skin
#
# $Id: pyukiwiki.skin.ja.cgi,v 1.5 2006/01/08 18:01:52 papu Exp $
#
# Copyright (C) 2004 by Nekyo.
# Copyright (C) 2006 PyukiWiki Developers Team
# License: GPL v2 or (at your option) any later version
# http://nekyo.hp.infoseek.co.jp/
# http://pyukiwiki.sourceforge.jp/
#
# Based on YukiWiki <hyuki@hyuki.com> http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
#
# 1TAB=4Spaces
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:UNIX=LF/Windows=CR+LF/Mac=CR
# Japanese Code=EUC
######################################################################

sub skin {
	my ($pagename, $body, $is_page, $bodyclass, $editable, $admineditable, $basehref) = @_;

	my($page,$message)=split(/\t/,$pagename);	
	my $cookedpage = &encode($page);
	my $escapedpage = &htmlspecialchars($page);
	my $HelpPage = &encode($::resource{help});

	if ($::last_modified != 0) {	# v0.0.9
		$lastmod = &date("Y-m-d H:i:s", (stat($::data_dir . "/" . &dbmname($page) . ".txt"))[9]);
	}

	if($::use_blosxom eq 1) {
		$::IN_HEAD.=<<EOD;
<link rel="stylesheet" href="$::skin_url/blosxom.css" type="text/css" media="screen" charset="Shift_JIS" />
EOD
	}

	if($::AntiSpam ne '') {
		$::IN_HEAD.=<<EOD;
<script type="text/javascript"><!--
var cs = "$::AntiSpam";
//--></script>
EOD
	}
	#v0.1.6
	if($::form{cmd}=~/edit|admin/) {
		$robot=<<EOD;
<meta name="robots" content="noindex,nofollow,noarchive">
<meta name="googlebot" content="noindex,nofollow,noarchive">
EOD
	} else {
		$robot=<<EOD;
<meta name="robots" content="index,follow">
<meta name="googlebot" content="index,follow,archive"> 
EOD
	}
	if($::wiki_title ne '') {
		$title="$::wiki_title - ";
	}
	print <<"EOD";
Content-type: text/html; charset=$::charset
$::HTTP_HEADER$::gzip_header
EOD
	if ($::gzip_header ne '') {
		open(STDOUT,"| $::gzip_path");
	}
	print <<"EOD";
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="$::lang">
<head>
<meta http-equiv="Content-Language" content="$::lang">
<meta http-equiv="Content-Type" content="text/html; charset=$::charset">
<title>$title$escapedpage @{[&htmlspecialchars(&get_subjectline($page))]}</title>
@{[$basehref eq '' ? '' : qq(<base href="$basehref">)]}
<link rel="stylesheet" href="$::skin_url/default.$::lang.css" type="text/css" media="screen" charset="Shift_JIS" />
<link rel="stylesheet" href="$::skin_url/print.$::lang.css" type="text/css" media="print" charset="Shift_JIS" />
@{[$::AntiSpam ne "" ? '' : qq(<link rev="made" href="mailto:$::modifier_mail">)]}
<link rel="top" href="$::script">
<link rel="index" href="$::script?cmd=list">
@{[$::use_SiteMap eq 1 ? qq(<link rel="contents" href="$::script?cmd=sitemap">) : '']}
<link rel="search" href="$::script?cmd=search">
<link rel="help" href="$::script?$HelpPage">
<meta name="description" content="$title$escapedpage @{[&htmlspecialchars(&get_subjectline($page))]}">
<meta name="author" content="$::modifier">
<meta name="copyright" content="$::modifier">
$robot
<script type="text/javascript" src="$::skin_url/common.$::lang.js"></script>
$::IN_HEAD
</head>
<body class="$bodyclass">
<div id="header">
 <a href="$::modifierlink"><img id="logo" src="$::image_url/pyukiwiki.png" width="80" height="80" alt="[PyukiWiki]" title="[PyukiWiki]" /></a>
EOD
	if($page ne '') {
		print <<EOD;
<h1 class="title"><a
    title="$::resource{searchthispage}"
    href="$::script?cmd=search&amp;mymsg=$cookedpage">@{[&htmlspecialchars($page)]}</a>@{[$message eq '' ? '' : "&nbsp;$message"]}</h1>
<a href="$::script?$cookedpage">$basehref?$cookedpage</a>
EOD
	} else {
		print <<EOD;
<h1 class="title">$message</h1>
EOD
	}
	print <<EOD;
</div>
<div id="navigator">

 [ <a href="$::script?$cookedpage">$::resource{reload}</a> ]
 &nbsp;
 [ <a href="$::script?cmd=newpage">$::resource{createbutton}</a>
 @{[ $editable
   ? qq( | <a title="$::resource{editthispage}" href="$::script?cmd=edit&amp;mypage=$cookedpage">$::resource{editbutton}</a>)
   : qq()
 ]}
 @{[ $admineditable
   ? qq( | <a title="$::resource{admineditthispage}" href="$::script?cmd=adminedit&amp;mypage=$cookedpage">$::resource{admineditbutton}</a>)
   : qq()
 ]}
 @{[ $admineditable
   ? qq( | <a href="$::script?cmd=diff&amp;mypage=$cookedpage">$::resource{diffbutton}</a>)
   : qq()
 ]}
 @{[ (-f "$::plugin_dir/attach.inc.pl")
   ? qq( | <a href="$::script?cmd=attach&amp;mypage=$cookedpage">$::resource{attachbutton}</a>)
   : qq()
 ]}
 ]
 &nbsp;
 [ <a href="$::script?$::FrontPage">$::resource{top}</a> | 
   <a href="$::script?cmd=list">$::resource{indexbutton}</a> | 
 @{[ $::use_SiteMap eq 1
   ? qq(<a href="$::script?cmd=sitemap">$::resource{sitemapbutton}</a> | )
   : qq()
 ]}
   <a href="$::script?cmd=search">$::resource{searchpage}</a> |
   <a href="$::script?$::RecentChanges">$::resource{recentchangesbutton}</a> |
   <a href="$::script?$HelpPage">$::resource{help}</a> ]
</div>
<hr class="full_hr" />
@{[ $::last_modified == 1
  ? qq(<div id="lastmodified">$::lastmod_prompt $lastmod</div>)
  : q()
]}
EOD

	if ($is_page || $::allview eq 1) {
		if (&is_exist_page($::Header)) {
			print "<div id=\"pageheader\">";
			&print_content($::database{$::Header}, $::form{mypage});
			print "</div>";
		}

		print <<"EOD";
<table border="0" style="width:100%">
  <tr>
    <td class="menubar">
    <div id="menubar">
EOD
		$::pushedpage = $::form{mypage};	# push;
		$::form{mypage} = $::MenuBar;
		#v0.1.6
		&print_content($::database{$::form{mypage}},$pushedpage);
		$::form{mypage} = $::pushedpage;	# pop

		print <<"EOD";
    </div>
    </td>
    <td valign=top>
      <div id="body">$body</div>
    </td>
  </tr>
</table>
EOD
		if (&is_exist_page($::Footer)) {
			print "<div id=\"pagefooter\">";
			&print_content($::database{$::Footer}, $::form{mypage});
			print "</div>";
		}
	} else {
		print <<"EOD";
<div id="body">$body</div>
EOD
	}

	if (@::notes) {
		print << "EOD";
<div id="note">
<hr class="note_hr" />
EOD
		my $cnt = 1;
		foreach my $note (@::notes) {
			print << "EOD";
<a id="notefoot_$cnt" href="#notetext_$cnt" class="note_super">*$cnt</a>
<span class="small">@{[&inline($note)]}</span>
<br />
EOD
			$cnt++;
		}
		print("</div>\n");
	}


	print <<"EOD";
<hr class="full_hr" />
<div id="toolbar"><a href="$::script?cmd=rss10"><img src="$::image_url/rss.png" border="0" /></a></div>
@{[ $::last_modified == 2
 ? qq(<div id="lastmodified">$::lastmod_prompt $lastmod</div>)
 : qq()
]}
<div id="footer">
EOD

	# y[Wtb^ wiki@
	my $footerbody=<<EOD;
@{[$::wiki_title ne '' ? qq(''[[$::wiki_title>$::script]]'' ) : '']}Modified by [[$::modifier>$::modifierlink]]~
~
''[[PyukiWiki $::version>PyukiWiki:FrontPage]]''
Copyright&copy; 2004-2006 by [[Nekyo>Nekyo:FrontPage]], [[PyukiWiki Developers Team>PyukiWiki:FrontPage]]
License is [[GPL>http://www.gnu.org/licenses/gpl@{[$::lang eq 'ja' ? '.ja' : '']}.html]]~
Based on "[[YukiWiki>YukiWiki:FrontPage]]" 2.1.0 by [[yuki>http://www.hyuki.com/yukiwiki/]]
and [[PukiWiki>PukiWiki:FrontPage]]
EOD
	print &text_to_html($footerbody);

	if ($::enable_convtime != 0) {
		printf('<br />HTML convert time to %.3f sec.%s<br />',
			((times)[0] - $_conv_start),
			($::gzip_header ne '') ? ' Compressed' : ''
		);
	}
	print <<"EOD";
</div>
</body>
</html>
EOD
}

1;
