######################################################################
# link.pl - This is PyukiWiki, yet another Wiki clone.
# link plugin
# from YukiWiki
#
# $Id: link.pl,v 1.1.1.1 2006/01/07 15:36:28 papu Exp $
#
# PyukiWiki Version 0.1.5a4-pre3
# Copyright (C) 2004 by Nekyo.
# Copyright (C) 2006 PyukiWiki Developers Team
# License: GPL v2 or (at your option) any later version
# http://nekyo.hp.infoseek.co.jp/
# http://pyukiwiki.sourceforge.jp/
#
# Based on YukiWiki <hyuki@hyuki.com> http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
#
# 1TAB=4Spaces
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:UNIX=LF/Windows=CR+LF/Mac=CR
# Japanese Code=EUC
######################################################################

use strict;

package link;

sub plugin_inline {
    my ($escaped_argument) = @_;
    my ($caption, $url) = split(/,/, $escaped_argument);
    if ($url =~ /^(mailto|http|https|ftp):/) {
        return qq(<a href="$url">$caption</a>);
    } else {
        return qq(&link($escaped_argument));
    }
}

sub plugin_usage {
    return {
        name => 'link',
        version => '1.1',
        author => 'Hiroshi Yuki <hyuki@hyuki.com>',
        syntax => '&link(caption,url)',
        description => 'Create link with given caption..',
        example => "Please visit &link(Hiroshi Yuki,http://www.hyuki.com/).",
    };
}

1;
